bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

FYI, _un_optimize cp's handling of zero-length regular files


From: Jim Meyering
Subject: FYI, _un_optimize cp's handling of zero-length regular files
Date: Sun, 29 Jul 2007 12:04:58 +0200

NEWS:

  cp attempts to read a regular file, even if stat says it is empty.
  Before, "cp /proc/cpuinfo c" would create an empty file when the kernel
  reports stat.st_size == 0, while "cat /proc/cpuinfo > c" would "work",
  and create a nonempty one. [bug introduced in coreutils-6.0]

Signed-off-by: Jim Meyering <address@hidden>
---
 ChangeLog              |   13 ++++++++++
 NEWS                   |    5 ++++
 THANKS                 |    1 +
 src/copy.c             |    1 -
 tests/cp/Makefile.am   |    1 +
 tests/cp/proc-zero-len |   59 ++++++++++++++++++++++++++++++++++++++++++++++++
 6 files changed, 79 insertions(+), 1 deletions(-)
 create mode 100755 tests/cp/proc-zero-len

diff --git a/ChangeLog b/ChangeLog
index 327e534..23136e8 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,16 @@
+2007-07-28  Jim Meyering  <address@hidden>
+
+       Attempt to copy a regular file, even if stat says it is empty.
+       * NEWS: Document this bug fix.
+       * src/copy.c (copy_reg): Read from a regular file, even if it
+       appears (stat.st_size == 0) to be empty.  This reverts an
+       optimization introduced on 2005-11-23 for coreutils-6.0.
+       Otherwise, "cp /proc/cpuinfo /tmp" creates an empty file,
+       on e.g., linux-2.6.20.
+       * tests/cp/proc-zero-len: New file.  Test for the above.
+       * tests/cp/Makefile.am (TESTS): Add proc-zero-len.
+       Reported by Dan Berrangé.
+
 2007-07-26  Bob Proulx  <address@hidden>

        sort: Improve sort --random-sort test.
diff --git a/THANKS b/THANKS
index 601ca8f..ae5269f 100644
--- a/THANKS
+++ b/THANKS
@@ -110,6 +110,7 @@ Dan Hagerty                         address@hidden
 Dan Jacobson                        http://www.geocities.com/jidani
 Dan Pascu                           address@hidden
 Daniel Bergstrom                    address@hidden
+Daniel P. Berrangé                  address@hidden
 Dániel Varga                        address@hidden
 Danny Levinson                      address@hidden
 Darren Salt                         address@hidden
diff --git a/src/copy.c b/src/copy.c
index 965dd76..ba79ed3 100644
--- a/src/copy.c
+++ b/src/copy.c
@@ -418,7 +418,6 @@ copy_reg (char const *src_name, char const *dst_name,
       goto close_src_and_dst_desc;
     }

-  if (! (S_ISREG (src_open_sb.st_mode) && src_open_sb.st_size == 0))
     {
       typedef uintptr_t word;
       off_t n_read_total = 0;
diff --git a/tests/cp/Makefile.am b/tests/cp/Makefile.am
index e3978c5..ecb7181 100644
--- a/tests/cp/Makefile.am
+++ b/tests/cp/Makefile.am
@@ -16,6 +16,7 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.

 TESTS = \
+  proc-zero-len \
   thru-dangling \
   cp-a-selinux \
   file-perm-race parent-perm-race \
diff --git a/tests/cp/proc-zero-len b/tests/cp/proc-zero-len
new file mode 100755
index 0000000..cd6f94c
--- /dev/null
+++ b/tests/cp/proc-zero-len
@@ -0,0 +1,59 @@
+#!/bin/sh
+# Ensure that cp copies contents of non-empty "regular" file with st_size==0
+
+# Copyright (C) 2007 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  cp --version
+fi
+
+. $srcdir/../envvar-check
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit 
$status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+touch empty || framework_failure=1
+
+if test $framework_failure = 1; then
+  echo "$0: failure in testing framework" 1>&2
+  (exit 1); exit 1
+fi
+
+f=/proc/cpuinfo
+test -r $f || f=empty
+
+fail=0
+cat $f > out || fail=1
+
+# With coreutils-6.9, this would create a zero-length "exp" file.
+cp $f exp || fail=1
+
+# Don't simply compare contents; they might differ,
+# e.g., if CPU freq changes between cat and cp invocations.
+# Instead, simply compare whether they're both nonempty.
+test -s out && { rm -f out; echo nonempty > out; }
+test -s exp && { rm -f exp; echo nonempty > exp; }
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail
--
1.5.3.rc3.13.g7ab3




reply via email to

[Prev in Thread] Current Thread [Next in Thread]